<?php
/*******************

 _ |. _ _ | _  _  _ _ '~)L~'~)
(_|||_\(_||(/_(/_| | | /__) /_


********************/
if ( ! defined( 'ABSPATH' ) ) exit;

// add_action( 'init','warrior_create_salesbooster_edd' );

add_action('edd_update_payment_status', 'warrior_salesbooster_edd_complete_order', 100, 3);

function warrior_create_salesbooster_edd() {
	warrior_create_salesbooster_edd_all_sales();
}

// Generate all sales in single array
function warrior_create_salesbooster_edd_all_sales() {
	global $wpdb;
	$options = get_option('warrior_edd_salesbooster_setting');
	$limit = 15;
	
	if( isset($options['sales-limit']) ) {
		$limit = intval($options['sales-limit']);
	}
	$args = array(
		'status' => 'publish',
		'number' => $limit,
		'fields' => 'ids'
	);

	$payments = edd_get_payments( $args );
	// $pargs = array('post_type' => 'product', 'posts_per_page' => -1, 'post_status'      => 'publish');
	// $products = get_posts( $pargs );

	$options['product-name-limit'] = !isset($options['product-name-limit']) ? 'unlimited' : $options['product-name-limit'];
	// var_dump( $payments ); exit();
	if ( !empty($payments) && is_array( $payments ) ) {
		$parsePurchases = array();
		//$parsePurchases = '([';
		$countorders = count( $payments );
		$counter = 0;

		foreach ( $payments as $order_id ) {
			$payment_meta = maybe_unserialize( get_post_meta( $order_id, '_edd_payment_meta', true ) );
			// echo '<pre>'; var_dump($payment_meta); echo '</pre>'; 
			
			$buyer = $payment_meta['user_info']['first_name'].' '.$payment_meta['user_info']['last_name'];
			// $city = get_post_meta($shop_order->ID,'_billing_city',true);
			$date_ori = ( $payment_meta['date'] != false ) ? $payment_meta['date'] : get_the_date('Y-m-d H:i:s O', $order_id );
			// var_dump($createat);
			// $create_iso = date(DATE_ISO8601, strtotime($createat));
			// $createat = strtotime($date_ori, get_option('gmt_offset'));
			// $createat = strtotime($date_ori, get_option('timezone_string'));
			$timezone = !empty( get_option('timezone_string') ) ? get_option('timezone_string') : 'UTC';
			$date = new DateTime($date_ori, new DateTimeZone( $timezone ));
			$date->setTimezone(new DateTimeZone('UTC'));

			$create_iso = date(DATE_ISO8601, strtotime($date->format('Y-m-d H:i:s O')));
			$createat = $date_ori;

			$items = $payment_meta['cart_details'];
			$gravatar = warrior_get_gravatar( $payment_meta['email'], false);

			foreach ( $items as $item ) {
				$productid = $item['id'];
				$raw_title = $item['name'];
				if($options['product-name-limit'] == 'unlimited'){
					$title = $raw_title;
				}
				else{
					$pieces = explode(" ", $raw_title);
					if( count($pieces) > intval($options['product-name-limit']) ){
						$pieces = array_slice($pieces, 0, intval($options['product-name-limit']));
						$title = implode(" ", $pieces);
						$title .= '...';
					}
					else{
						$title = implode(" ", $pieces);
					}
				}

				$producttitle = $title;
				$productimages = wp_get_attachment_image_src( get_post_thumbnail_id( $productid ) , 'shop_thumbnail' );
				//$productimages = wp_get_attachment_thumb_url($productid);
				// print_r($productimages);
				$producturl = get_permalink( $productid );
				$parsePurchases[] = array(
					'buyer' => $buyer,
					'id' => $order_id.'-'.$productid,
					'product_id' => $productid,
					'order_id' => $order_id,
					// 'country' => $country,
					'created_at' => $createat,
					'created_iso' => $create_iso,
					'product_title' => $producttitle,
					'image' => $productimages[0],
					'gravatar' => $gravatar,
					'url' => $producturl
				);
			} //close foreach reasult
			// print_r($parsePurchases);
			$counter++;
		} //close foreach loop
		//$parsePurchases .= '])';
		// echo '<pre>';
		// var_dump($parsePurchases);
		// echo '</pre>';
		// exit();
		$parsePurchases = json_encode( $parsePurchases );
		$filename = WARRIOREDDNOTIF.'/json/file.json';
		$file = fopen($filename, 'w');
		fwrite( $file, $parsePurchases );
		fclose( $file );
	}// close if shop_orders array
} //close function

function warrior_salesbooster_edd_complete_order( $order_id, $new_status, $old_status ) {
	if ( $old_status == 'publish' || $old_status == 'complete' ) {
		return; // Make sure that payments are only completed once
	}
	// Make sure the payment completion is only processed when new status is complete
	if ( $new_status != 'publish' && $new_status != 'complete' ) {
		return;
	}

	$options = get_option('warrior_edd_salesbooster_setting');

	$filename = WARRIOREDDNOTIF.'/json/file.json';
	$string = file_get_contents($filename);
	$parsePurchases = json_decode($string, true);
	// var_dump($parsePurchases);
	$payment_meta = maybe_unserialize( get_post_meta( $order_id, '_edd_payment_meta', true ) );
	$buyer = $payment_meta['user_info']['first_name'].' '.$payment_meta['user_info']['last_name'];
	// $city = get_post_meta($shop_order->ID,'_billing_city',true);
	$date_ori = ( $payment_meta['date'] != false ) ? $payment_meta['date'] : get_the_date('Y-m-d H:i:s O', $order_id );
	$date = new DateTime($date_ori, new DateTimeZone(get_option('timezone_string')));
	$date->setTimezone(new DateTimeZone('UTC'));

	$create_iso = date(DATE_ISO8601, strtotime($date->format('Y-m-d H:i:s O')));
	$createat = $date_ori;
	$items = $payment_meta['cart_details'];
	$gravatar = warrior_get_gravatar( $payment_meta['email'], false);
	// var_dump($items);
	foreach ( $items as $item ) {
		$productid = $item['id'];
		$raw_title = $item['name'];
		if($options['product-name-limit'] == 'unlimited'){
			$title = $raw_title;
		}
		else{
			$pieces = explode(" ", $raw_title);
			if( count($pieces) > intval($options['product-name-limit']) ){
				$pieces = array_slice($pieces, 0, intval($options['product-name-limit']));
				$title = implode(" ", $pieces);
				$title .= '...';
			}
			else{
				$title = implode(" ", $pieces);
			}
		}

		$producttitle = $title;
		$productimages = wp_get_attachment_image_src( get_post_thumbnail_id( $productid ) , 'shop_thumbnail' );

		$producturl = get_permalink( $productid );
		$parsePurchases[] = array(
			'buyer' => $buyer,
			'id' => $order_id.'-'.$productid,
			'product_id' => $productid,
			'order_id' => $order_id,
			'created_at' => $createat,
			'created_iso' => $create_iso,
			'product_title' => $producttitle,
			'image' => $productimages[0],
			'gravatar' => $gravatar,
			'url' => $producturl
		);
	}
	// echo'<pre>';
	// var_dump($parsePurchases);
	// echo'</pre>';
	// exit();
	$parsePurchases = json_encode( $parsePurchases );
	
	$file = fopen($filename, 'w');
	fwrite( $file, $parsePurchases );
	fclose( $file );
}

function warrior_get_gravatar( $email, $img = false, $s = 80, $d = 'mp', $r = 'g', $atts = array() ){
	$url = 'https://www.gravatar.com/avatar/';
	$url .= md5( strtolower( trim( $email ) ) );
	$url .= "?s=$s&d=$d&r=$r";
	if ( $img ) {
		$url = '<img src="' . $url . '"';
		foreach ( $atts as $key => $val )
			$url .= ' ' . $key . '="' . $val . '"';
		$url .= ' />';
	}
	return $url;
}