<?php
if ( ! defined( 'ABSPATH' ) ) exit;
/***************
*
* Initiliaze Our Plugin Here

 _ |. _ _ | _  _  _ _ '~)L~'~)
(_|||_\(_||(/_(/_| | | /__) /_

****************/

define( 'WARRIOR_EDDBOOSTER_STORE_URL', 'https://cepatlakoo.com' );
define( 'WARRIOR_EDDBOOSTER_ITEM_NAME', 'EDD Sales Notification' );
define( 'WARRIOR_EDDBOOSTER_PLUGIN_LICENSE_PAGE', 'edit.php?post_type=download&page=warrior_sales_notification' );

if( !class_exists( 'CL_Plugin_Updater' ) ) {
	// load our custom updater
	include( dirname( __FILE__ ) . '/inc/cl-plugin-updater.php' );
}
$updater = new CL_Plugin_Updater;

/* Add Menu and Stuff */
add_action( 'admin_menu','warrior_edd_salesbooster_options' );
function warrior_edd_salesbooster_options() {
	add_submenu_page( 'edit.php?post_type=download', 'Warrior Sales Notification', 'Sales Notification', 'manage_options', 'warrior_sales_notification', 'warrior_edd_sales_booster_manage_options' );
} //close function

/**
 * Add new setting group
 */
add_action( 'admin_init', 'warrior_edd_salesbooster_init' );
function warrior_edd_salesbooster_init() {
	// register_setting( 'warrior_salesbooster', 'warrior_edd_salesbooster_setting' );
	add_option( 'warrior_edd_salesbooster_setting', array() );
}

function warrior_sales_booster_edd_options_success() {
    ?>
    <div class="notice notice-success is-dismissible">
        <p><?php esc_html_e( 'Setting Saved.', 'edd-sales-notification' ) ?></p>
    </div>
    <?php
}

function warrior_edd_sales_booster_manage_options() {
	if ( isset($_POST['warrior_sales_notif_submit'] ) ) {
		$enable = isset( $_POST['warrior_edd_enable_salesbooster'] ) ? ( $_POST['warrior_edd_enable_salesbooster'] == 'yes' ? 'yes' : '' ) : '';

		$status  = get_option( 'warrior_edd_salesbooster_setting_status' );
		if( $status != false && $status->license != 'valid' ){
			$enable = '';
		}
		
		if ( isset( $_POST['warrior_edd_enable_salesbooster'] ) ) {
			update_option( 'warrior_edd_enable_salesbooster', $enable );
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting_key'] ) ) {
			update_option( 'warrior_edd_salesbooster_setting_key', $_POST['warrior_edd_salesbooster_setting_key'] );
		}

		$old_opt = get_option('warrior_edd_salesbooster_setting');
		// Or generate the Original Json File

		$option_array = array();
		$warrior_marketplace = array();
		$option_array['display-name'] = '0';
		$option_array['display-gravatar'] = '0';
		$option_array['sales-limit'] = 15;
		$option_array['sales-min-delay'] = 3;
		$option_array['sales-max-delay'] = 20;
		$option_array['auto-update'] = 'daily';
		$option_array['display-random'] = '0';
		$option_array['purchase-date'] = '1';
		$option_array['product-name-limit'] = 'unlimited';
		// var_dump($old_opt);
		// var_dump($_POST); exit();

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['display-name'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
			$option_array['display-name'] = '1';
		} else {
			if ( isset( $_POST['warrior_edd_enable_salesbooster'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
				$option_array['display-name'] = 0;
			} elseif ( isset( $old_opt['display-name'] ) ) {
				$option_array['display-name'] = $old_opt['display-name'];
			}
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['display-gravatar'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
			$option_array['display-gravatar'] = '1';
		} else {
			if ( isset( $_POST['warrior_edd_enable_salesbooster'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
				$option_array['display-gravatar'] = 0;
			} elseif ( isset( $old_opt['display-gravatar'] ) ) {
				$option_array['display-gravatar'] = $old_opt['display-gravatar'];
			}
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['sales-limit'] ) ) {
        	$option_array['sales-limit'] = $_POST['warrior_edd_salesbooster_setting']['sales-limit'];
		} else {
			if ( isset( $old_opt['sales-limit'] ) )
				$option_array['sales-limit'] = $old_opt['sales-limit'];
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['sales-min-delay'] ) ) {
        	$option_array['sales-min-delay'] = $_POST['warrior_edd_salesbooster_setting']['sales-min-delay'];
		} else {
			if ( isset( $old_opt['sales-min-delay'] ) )
				$option_array['sales-min-delay'] = $old_opt['sales-min-delay'];
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['sales-max-delay'] ) ) {
        	$option_array['sales-max-delay'] = $_POST['warrior_edd_salesbooster_setting']['sales-max-delay'];
		} else {
			if ( isset( $old_opt['sales-max-delay'] ) )
				$option_array['sales-max-delay'] = $old_opt['sales-max-delay'];
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['auto-update'] ) ) {
			$option_array['auto-update'] = $_POST['warrior_edd_salesbooster_setting']['auto-update'];
			if ( $time = wp_next_scheduled( 'warrior_salesbooster_cron' ) )
				wp_unschedule_event( $time, 'warrior_salesbooster_cron' );

			wp_schedule_event( time(), $_POST['warrior_edd_salesbooster_setting']['auto-update'], 'warrior_salesbooster_cron' );
		} else {
			if ( isset( $old_opt['auto-update'] ) )
				$option_array['auto-update'] = $old_opt['auto-update'];
		}

		if ( isset( $_POST['warrior_edd_salesbooster_setting']['display-random'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
        	$option_array['display-random'] = $_POST['warrior_edd_salesbooster_setting']['display-random'];
		} else {
			if ( isset( $_POST['warrior_edd_enable_salesbooster'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
				$option_array['display-random'] = 0;
			} elseif ( isset( $old_opt['display-random'] ) ) {
				$option_array['display-random'] = $old_opt['display-random'];
			}
		}
		
		if ( isset( $_POST['warrior_edd_salesbooster_setting']['purchase-date'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
        	$option_array['purchase-date'] = $_POST['warrior_edd_salesbooster_setting']['purchase-date'];
		} else {
			if ( isset( $_POST['warrior_edd_enable_salesbooster'] ) && $_POST['warrior_edd_enable_salesbooster'] == 'yes' ) {
				$option_array['purchase-date'] = 0;
			} elseif ( isset( $old_opt['purchase-date'] ) ) {
				$option_array['purchase-date'] = $old_opt['purchase-date'];
			}
		}
		
		if ( isset( $_POST['warrior_edd_salesbooster_setting']['product-name-limit'] ) ) {
        	$option_array['product-name-limit'] = $_POST['warrior_edd_salesbooster_setting']['product-name-limit'];
		} else {
			if ( isset( $old_opt['product-name-limit'] ) )
				$option_array['product-name-limit'] = $old_opt['product-name-limit'];
		}
		
		update_option('warrior_edd_salesbooster_setting', $option_array);
		warrior_sales_booster_edd_options_success();
		warrior_create_salesbooster_edd();
	}
	$active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'booster';
	?>

	<div id="wrap">
		<h2><?php esc_html_e( 'Warrior Sales Notification for Easy Digital Downloads', 'edd-sales-notification' ) ?></h2>
		
		<form method="post" action="">
			<?php
			settings_fields( 'warrior_salesbooster' );
			global $warrior_options;
			$options = get_option('warrior_edd_salesbooster_setting');
			?>

			<table class="form-table">
			<?php do_settings_sections( 'warrior_booster' );
			$key = !empty( get_option('warrior_edd_salesbooster_setting_key') ) ? get_option('warrior_edd_salesbooster_setting_key') : '';
			$status  = get_option( 'warrior_edd_salesbooster_setting_status' );
			// var_dump($status);
			if( $status != false && ($status->license == 'valid' || $status->license == 'expired' ) ){
				$license_msg = 'License Key : <span class="warrior-edd-salesbooster-msg-active">'.$status->license.'</span>. Valid until : <span class="warrior-edd-salesbooster-msg-active">'.date( get_option('date_format'), strtotime($status->expires) ).'</span>. Key has been used in : <span class="warrior-edd-salesbooster-msg-active">'.$status->site_count.'/'.$status->license_limit.'</span> website';
			}
			else{
				$license_msg = __( 'Get your license key on :', 'edd-sales-notification' ). '<a href="'.WARRIOR_EDDBOOSTER_STORE_URL.'" target="_blank"> '.WARRIOR_EDDBOOSTER_STORE_URL.'</a>';
			}
			?>
				<tr>
					<th scope="row">
						<label for="warrior_edd_salesbooster_information"><?php echo esc_html__('License Key', 'edd-sales-notification'); ?></label>
					</th>
					<td>
						<input type="text" class="warrior-edd-salesbooster-license-key-field" name="warrior_edd_salesbooster_setting_key" placeholder="<?php esc_html_e( 'License Key', 'edd-sales-notification' ); ?>" <?php echo (!empty($key) ) ? 'value="'.$key.'"' : ''; ?> <?php echo ($status != false && $status->license == 'valid') ? 'readonly style="display:block"' : ''; ?>>
						<span class="description"><?php echo $license_msg; ?></span>
					</td>
				</tr>
				
				<tr>
					<th scope="row">
						<label for="warrior_edd_salesbooster_information"><?php echo esc_html__('Status License', 'edd-sales-notification'); ?></label>
					</th>
					<td>
						<?php if( $status !== false && isset($status->license) && $status->license == 'valid' ) {
							wp_nonce_field( 'warrior_edd_booster_nonce', 'warrior_edd_booster_nonce' ); ?>
							<input type="submit" class="button-secondary" name="warrior_edd_booster_license_deactivate" value="<?php _e('Deactivate License', 'edd-sales-notification'); ?>"/>
						<?php } else {
							wp_nonce_field( 'warrior_edd_booster_nonce', 'warrior_edd_booster_nonce' ); ?>
							<input type="submit" class="button-secondary" name="warrior_edd_booster_license_activate" value="<?php _e('Activate License', 'edd-sales-notification'); ?>"/>
						<?php } ?>
					</td>
				</tr>
				<?php if( $status != false && ($status->license == 'valid') ) : ?>
					<tr>
						<th scope="row"><label for="blogname"><?php esc_html_e( 'Enable Sales Booster', 'edd-sales-notification' ) ?></label>
						</th>
						<td>
							<input type="radio" name="warrior_edd_enable_salesbooster" id="salesbooster_yes" value="yes" <?php $option = get_option( 'warrior_edd_enable_salesbooster' ); echo ( $option == 'yes' ? 'checked' : '' );?>/>
							<label for="salesbooster_yes"><?php esc_html_e( 'Yes','edd-sales-notification' ) ?></label>
							<input type="radio" name="warrior_edd_enable_salesbooster" id="salesbooster_no" value="no" <?php $option = get_option( 'warrior_edd_enable_salesbooster' ); echo ( $option == '' ? 'checked' : '' );?>/>
							<label for="salesbooster_no"><?php esc_html_e( 'No', 'edd-sales-notification' ) ?></label>
						</td>
					</tr>

					<tr>
						<th scope="row"><?php esc_html_e( 'Display buyer\'s name?', 'edd-sales-notification' ); ?></th>
						<td>
							<label for="display-name">
								<input type="checkbox" id="display-name" name="warrior_edd_salesbooster_setting[display-name]" value="1" <?php checked( '1', @$options['display-name'] ); ?> />
								<?php esc_html_e( 'Yes', 'edd-sales-notification' ); ?>
							</label>
						</td>
					</tr>

					<tr>
						<th scope="row"><?php esc_html_e( 'Display User Gravatar?', 'edd-sales-notification' ); ?></th>
						<td>
							<label for="display-gravatar">
								<input type="checkbox" id="display-gravatar" name="warrior_edd_salesbooster_setting[display-gravatar]" value="1" <?php checked( '1', @$options['display-gravatar'] ); ?> />
								<?php esc_html_e( 'Yes', 'edd-sales-notification' ); ?>
							</label>
						</td>
					</tr>

					<tr>
						<th scope="row">
							<label for="sales-limit"><?php esc_html_e( 'Number of sales displayed:', 'edd-sales-notification' ); ?></label>
						</th>
						<td>
							<?php
							$limit = 15;
							if ( isset( $options['sales-limit'] ) ) {
								$limit = $options['sales-limit'];
							}
							?>
							<input type="number" id="sales-limit" name="warrior_edd_salesbooster_setting[sales-limit]" value="<?php echo esc_attr( $limit ); ?>" step="1" min="1" style="width:80px;" />
						</td>
					</tr>

					<tr>
						<th scope="row">
							<label for="sales-min-delay"><?php esc_html_e( 'Set minimal delay', 'edd-sales-notification' ); ?></label>
						</th>
						<td>
							<?php
							$min_delay = 5;
							if ( isset( $options['sales-min-delay'] ) ) {
								$min_delay = $options['sales-min-delay'];
							}
							?>
							<input type="number" id="sales-min-delay" name="warrior_edd_salesbooster_setting[sales-min-delay]" value="<?php echo esc_attr( $min_delay ); ?>" step="1" min="3" max="6" style="width:80px;" />
							<?php esc_html_e( 'seconds', 'edd-sales-notification' ); ?>
							<p class="description"><?php esc_html_e( 'Minimum delay time between each notification.', 'edd-sales-notification' ); ?></p>
						</td>
					</tr>

					<tr>
						<th scope="row">
							<label for="sales-max-delay"><?php esc_html_e( 'Set maxmimum delay', 'edd-sales-notification' ); ?></label>
						</th>
						<td>
							<?php
							$max_delay = 10;
							if ( isset( $options['sales-max-delay'] ) ) {
								$max_delay = $options['sales-max-delay'];
							}
							?>
							<input type="number" id="sales-max-delay" name="warrior_edd_salesbooster_setting[sales-max-delay]" value="<?php echo esc_attr( $max_delay ); ?>" step="1" min="4" max="20" style="width:80px;" />
							<?php esc_html_e( 'seconds', 'edd-sales-notification' ); ?>
							<span class='warrior-sales-delay-error' style="display:none; color:red"> <br><?php esc_html_e( 'Max value must greater than min value', 'edd-sales-notification' ); ?> </span>
							<p class="description"><?php esc_html_e( 'Maximum delay time between each notification.', 'edd-sales-notification' ); ?></p>
						</td>
					</tr>

					<tr>
						<th scope="row"><?php esc_html_e('Display randomly?', 'edd-sales-notification'); ?></th>
						<td>
							<label for="display-random">
								<input type="checkbox" id="display-random" name="warrior_edd_salesbooster_setting[display-random]" value="1" <?php checked( @$options['display-random'], '1' ); ?> />
								<?php esc_html_e( 'Yes', 'edd-sales-notification' ); ?>
							</label>
						</td>
					</tr>

					<tr>
						<th scope="row">
							<label for="sales-min-delay"><?php esc_html_e( 'Product Name Length', 'edd-sales-notification' ); ?></label>
						</th>
						<td>
							<select name="warrior_edd_salesbooster_setting[product-name-limit]">
								<option value="unlimited" <?php echo ( @$options['product-name-limit'] == 'unlimited' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Unlimited', 'edd-sales-notification' ); ?></option>
								<?php for ( $i=1; $i < 11; $i++ ) : ?> 
									<option value="<?php echo $i; ?>" <?php echo ( @$options['product-name-limit'] == $i ) ? 'selected' : ''; ?>><?php echo $i; ?></option>
								<?php endfor; ?>
							</select>
							<?php esc_html_e( 'Word(s)', 'edd-sales-notification' ); ?>
						</td>
					</tr>

					<tr>
						<th scope="row"><?php esc_html_e( 'Display purchase date', 'edd-sales-notification' ); ?></th>
						<td>
							<label for="purchase-date">
								<input type="checkbox" id="purchase-date" name="warrior_edd_salesbooster_setting[purchase-date]" value="1" <?php checked( @$options['purchase-date'], '1' ); ?> />
								<?php esc_html_e( 'Yes', 'edd-sales-notification' ); ?>
							</label>
						</td>
					</tr>
					
					<tr>
						<th scope="row">
							<label for="auto-update"><?php esc_html_e( 'Auto Update Order List', 'edd-sales-notification' ); ?></label>
						</th>
						<td>
							<select name="warrior_edd_salesbooster_setting[auto-update]">
								<option value="hourly" <?php echo ( @$options['auto-update'] == 'hourly' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Every 1 Hour', 'edd-sales-notification' ); ?></option>
								<option value="warrior_3_hours" <?php echo ( @$options['auto-update'] == 'warrior_3_hours' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Every 3 Hours', 'edd-sales-notification' ); ?></option>
								<option value="warrior_6_hours" <?php echo ( @$options['auto-update'] == 'warrior_6_hours' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Every 6 Hours', 'edd-sales-notification' ); ?></option>
								<option value="twicedaily" <?php echo ( @$options['auto-update'] == 'twicedaily' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Every 12 Hours', 'edd-sales-notification' ); ?></option>
								<option value="daily" <?php echo ( (@$options['auto-update'] == 'daily') || ( !isset($options['auto-update']) ) ) ? 'selected' : ''; ?>><?php esc_html_e( 'Daily', 'edd-sales-notification' ); ?></option>
								<option value="warrior_weekly" <?php echo ( @$options['auto-update'] == 'warrior_weekly' ) ? 'selected' : ''; ?>><?php esc_html_e( 'Weekly', 'edd-sales-notification' ); ?></option>
							</select>
						</td>
					</tr>
				<?php endif; ?>
	            <tr>
	             	<td></td>
	             	<td><input type="submit" name="warrior_sales_notif_submit" class="button-primary warrior-sales-submit" value="<?php esc_html_e( 'Save Changes', 'edd-sales-notification' ); ?>" /></td>
	            </tr>
        	</table>
    	</form>
	</div>
	<script>
		jQuery('#sales-max-delay, #sales-min-delay').change(function(){
			if ( parseInt(jQuery('#sales-min-delay').val()) >= parseInt(jQuery('#sales-max-delay').val()) ){
				jQuery('.warrior-sales-delay-error').show();
				jQuery('.warrior-sales-submit').prop('disabled', true);
			}
			else{
				jQuery('.warrior-sales-submit').prop('disabled', false);
				jQuery('.warrior-sales-delay-error').hide();
			}
		});
	</script>
<?php
}

function warrior_edd_salesbooster_async_scripts( $url ) {
    if ( strpos( $url, '#asyncload') === false ) {
        return $url;
    } else if ( is_admin() ) {
        return str_replace( '#asyncload', '', $url );
    } else {
    	return str_replace( '#asyncload', '', $url )."' async=async";
    }
}
add_filter( 'clean_url', 'warrior_edd_salesbooster_async_scripts', 11, 1 );

function warrior_edd_salesbooster_theme_scripts() {
	global $product;

    $showNotify = get_post_meta( get_the_ID(), 'notify_meta_checkbox' ) ? get_post_meta( get_the_ID(), 'notify_meta_checkbox' )[0] : '';
	wp_enqueue_style( 'warrior-edd-sales-booster-css', plugin_dir_url( __FILE__ ) . 'css/warrior-edd-sales-notification.css' );

    if ( $showNotify == 'on' ) {
		$notify_enabled = get_option( 'warrior_edd_enable_salesbooster' );
		
		if ( $notify_enabled != 'yes' ) {
			return;
		}

		$cs_options = get_option( 'warrior_edd_salesbooster_setting' );
		$display_name = @$cs_options['display-name'];
		$display_gravatar = @$cs_options['display-gravatar'];
		$show_date = @$cs_options['purchase-date'];
		$min_delay = @$cs_options['sales-min-delay'];
		$max_delay = @$cs_options['sales-max-delay'];
		$display_random = @$cs_options['display-random'];

		$booster = 'booster.dev.js';
		// $booster = 'booster.min.js';

		// if ( $display_random == '1' ) {
		// 	$booster = 'booster-random.dev.js';
		// }

		if( isset($product) || is_page( get_the_ID() ) ) {
			$product_id = get_the_ID();
			$page_type = ( is_page( get_the_ID()) ) ? 'page' : 'product';
		}
		else{
			$product_id = '';
			$page_type = '';
		}

		// wp_enqueue_script( 'warrior_edd_notif', plugin_dir_url( __FILE__ ) . 'js/booster.min.js#asyncload', 'jquery', '', true );
		wp_enqueue_script( 'warrior_edd_notif', plugin_dir_url( __FILE__ ) . 'js/'.$booster.'#asyncload', 'jquery', '', true );
      	wp_localize_script( 'warrior_edd_notif', 'warrior_edd_notif', array(
            'folder'		=> plugins_url( '/json/',__FILE__),
            'admin_url'		=> admin_url('admin-ajax.php'),
            'product_id'	=> $product_id,
            'page_type'		=> $page_type,
            'translation'	=> array(
                                esc_html__('Someone', 'edd-sales-notification'),
                                esc_html__('Have just purchased', 'edd-sales-notification'),
                                esc_html__('ago', 'edd-sales-notification'),
                                esc_html__('from now', 'edd-sales-notification'),
                                esc_html__('less than a minute', 'edd-sales-notification'),
                                esc_html__('about a minute', 'edd-sales-notification'),
                                esc_html__('minutes', 'edd-sales-notification'),
                                esc_html__('about an hour', 'edd-sales-notification'),
                                esc_html__('about', 'edd-sales-notification'),
                                esc_html__('hours', 'edd-sales-notification'),
                                esc_html__('a day', 'edd-sales-notification'),
                                esc_html__('days', 'edd-sales-notification'),
                                esc_html__('about a month', 'edd-sales-notification'),
                                esc_html__('months', 'edd-sales-notification'),
                                esc_html__('about a year', 'edd-sales-notification'),
                                esc_html__('years', 'edd-sales-notification'),
                              ),
			'display_name'		=> $display_name,
			'display_gravatar'	=> $display_gravatar,
			'display_random'	=> $display_random,
			'show_date'			=> $show_date,
			'min_delay'			=> $min_delay,
			'max_delay'			=> $max_delay,
      	));
    };
}
add_action( 'wp_enqueue_scripts', 'warrior_edd_salesbooster_theme_scripts');

function warrior_edd_salesbooster_admin_script() {
	wp_enqueue_media();
	wp_register_script( 'warrior-salesbooster-functions-admin', plugin_dir_url( __FILE__ ) . 'js/warrior-function-admin.js', array('jquery','media-upload','thickbox', 'jquery-ui-sortable', 'wp-color-picker'), '1.0.0', true );
	if( get_current_screen()->id == 'woocommerce_page_warrior_sales_booster'){
		wp_enqueue_script('jquery');
 
        wp_enqueue_script('thickbox');
        wp_enqueue_style('thickbox');
 
        wp_enqueue_script('media-upload');
		wp_enqueue_script('warrior-salesbooster-functions-admin');
	}
}
add_action( 'admin_enqueue_scripts', 'warrior_edd_salesbooster_admin_script' );

function warrior_edd_salesbooster_custom_meta() {
    add_meta_box( 'themewarior_sales_notify', esc_html__( 'Themewarrior Sales Notification', 'edd-sales-notification' ), 'warrior_edd_salesbooster_meta_callback', 'page' );
}
add_action( 'add_meta_boxes', 'warrior_edd_salesbooster_custom_meta' );

function warrior_edd_salesbooster_meta_callback() {
    // $post is already set, and contains an object: the WordPress post
    global $post;

    $check = get_post_meta( $post->ID , 'notify_meta_checkbox' ) ? esc_attr( get_post_meta( $post->ID , 'notify_meta_checkbox' )[0] ) : '';

    // We'll use this nonce field later on when saving.
    wp_nonce_field( 'my_meta_box_nonce', 'meta_box_nonce' );
    ?>
    <p>
        <input type="checkbox" id="notify_meta_checkbox" name="notify_meta_checkbox" <?php checked( $check, 'on' ); ?> />
        <label for="notify_meta_checkbox"><?php esc_html_e( 'Display sales booster notification in this page', 'edd-sales-notification' ) ?></label>
    </p>
	<?php
	$args = array(
        'post_type'      => 'download',
        'posts_per_page' => -1
    );
	$product_loop = new WP_Query( $args );
	$selected = get_post_meta($post->ID, '_warrior_salesboster_id', true);
	
	?>
	<div class="warrior-cr-admin-post-form">
		<table class="form-table">
			<tbody>
				<tr style="display:none" class="warrior_marketplace_custom_id_tr">
					<th scope="row">
						<label for="warrior_marketplace_custom_id"><?php echo esc_html__( 'Select Product(s)', 'edd-sales-notification' ); ?></label>
					</th>
					<td>
						<select name="warrior_salesbooster_custom_id[]" multiple="multiple" style="max-width: inherit; width:100%;" id="warrior_marketplace_custom_id">
							<?php while ( $product_loop->have_posts() ) : $product_loop->the_post(); ?>
								<option value="<?php echo get_the_ID(); ?>" <?php echo ( (is_array($selected) && in_array(get_the_ID(), $selected)) || (get_the_ID() == $selected) || empty($selected) ) ? 'selected' : '' ?>><?php echo get_the_title(); ?></option>
							<?php endwhile; ?>
						</select>
						<p class="description"><?php echo esc_html__( 'Will only display sales notification from the above selected product(s).', 'edd-sales-notification' ); ?></p>
					</td>
				</tr>
			</tbody>
		</table>
	</div>
	<script>
		jQuery('#notify_meta_checkbox').change(function() {
			if( jQuery(this).is(":checked") ) {
				jQuery('.warrior_marketplace_custom_id_tr').show();
			}
			else{
				jQuery('.warrior_marketplace_custom_id_tr').hide();
			}      
		});
	</script>
    <?php
}

add_action( 'save_post', 'warrior_edd_salesbooster_meta_box_save' );
function warrior_edd_salesbooster_meta_box_save( $post_id ) {
    // Bail if we're doing an auto save
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) return;
	
    // if our nonce isn't there, or we can't verify it, bail
    if ( !isset( $_POST['meta_box_nonce'] ) || !wp_verify_nonce( $_POST['meta_box_nonce'], 'my_meta_box_nonce' ) ) return;

    // if our current user can't edit this post, bail
	if ( !current_user_can( 'edit_post' ) ) return;
		
	if ( array_key_exists( 'warrior_salesbooster_custom_id', $_POST ) ) {
		update_post_meta(
			$post_id,
			'_warrior_salesboster_id',
			$_POST['warrior_salesbooster_custom_id']
		);
	}
	else{
		update_post_meta(
			$post_id,
			'_warrior_salesboster_id',
			'off'
		);
	}

    // This is purely my personal preference for saving check-boxes
    $chk = isset( $_POST['notify_meta_checkbox'] ) ? 'on' : 'off';
    update_post_meta( $post_id, 'notify_meta_checkbox', $chk );
}

load_plugin_textdomain( 'edd-sales-notification', false, dirname(plugin_basename(__FILE__)) . '/languages/' );

add_action( 'wp_ajax_warrior_booster_edd_datas', 'warrior_edd_salesbooster_datas' );
add_action( 'wp_ajax_nopriv_warrior_booster_edd_datas', 'warrior_edd_salesbooster_datas' );
function warrior_edd_salesbooster_datas(){
	$options = get_option('warrior_edd_salesbooster_setting');
	$limit = 15;
	
	if( isset($options['sales-limit']) ) {
		$limit = intval($options['sales-limit']);
	}
	
	$id = ( isset($_POST['id']) && !empty($_POST['id']) ) ? $_POST['id'] : '';
	$page_type = ( isset($_POST['page_type']) && !empty($_POST['page_type']) ) ? $_POST['page_type'] : '';

	$filename = WARRIOREDDNOTIF.'/json/file.json';
	$string = file_get_contents($filename);
	$datas = json_decode($string, true);
	$check = false;
	$ret = '';

	if( !empty($id) ){
		$selected = array();
		
		if ( $page_type == 'page' ){
			$selected = get_post_meta($id, '_warrior_salesboster_id', true);
			$check = true;
		}
		
		if ( $check && !empty($selected) ){
			$ret_arr = array();
			foreach($datas as $data){
				if( ($data['product_id'] == $id) || ( is_array($selected) && in_array($data['product_id'], $selected) ) ){
					$ret_arr[] = $data;
				}
			}
			if( count($ret_arr) > 0 )
				$datas = $ret_arr;
		}
	}

	if( count($datas) > $limit ){
		$datas = array_slice($datas, 0, $limit);
	}
	$parsePurchases = json_encode( $datas );
	$ret = 'parsePurchases( '.$parsePurchases.' )';

	echo $ret; die();
}