<?php
/*************************
	* Plugin Name: EDD Sales Notification
	* Plugin URI: https://themewarrior.com
	* Description: This is an extension for Easy Digital Downloads plugin, It will promote your recent sales and notify visitors about it. Forked from the original Woo Sales Notify plugin from alisaleem252
	* Version: 1.0.0
	* Author: ThemeWarrior
	* Author URI: https://themewarrior.com
	* Text Domain: edd-sales-notification
	* Domain Path: /languages
*
 _ |. _ _ | _  _  _ _ '~)L~'~)
(_|||_\(_||(/_(/_| | | /__) /_

*************************/


if ( ! defined( 'ABSPATH' ) ) exit;
if ( in_array( 'easy-digital-downloads/easy-digital-downloads.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
	
	define('WARRIOREDDNOTIF', dirname(__FILE__) );
	require_once( WARRIOREDDNOTIF.'/inc/filejson.php' );
	require_once( WARRIOREDDNOTIF.'/init.php' );
		function warrior_edd_salesbooster_settings_link( $links ) {
			$settings_link = '<a href="admin.php?page=warrior_sales_notification">'. esc_html__( 'Settings', 'edd-sales-notification' ) .'</a>';
			array_unshift($links, $settings_link);
			return $links;
		}

		$plugin = plugin_basename(__FILE__);
		add_filter( 'plugin_action_links_$plugin', 'warrior_edd_salesbooster_settings_link' );

		/*Hook Some Action during Activation */
		register_activation_hook( __FILE__, 'warrior_edd_salesbooster_activation' );  //activation hook for Schedule hook

	    function warrior_edd_salesbooster_load_plugin_textdomain() {
	    	$domain = 'edd-sales-notification';
	    	$locale = apply_filters( 'plugin_locale', get_locale(), $domain );
	    	// wp-content/languages/plugin-name/plugin-name-de_DE.mo
	    	load_textdomain( $domain, trailingslashit( WP_LANG_DIR ) . $domain . '/' . $domain . '-' . $locale . '.mo' );
	    	// wp-content/plugins/plugin-name/languages/plugin-name-de_DE.mo
	    	load_plugin_textdomain( $domain, FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
	    }
		add_action( 'init', 'warrior_edd_salesbooster_load_plugin_textdomain' );

    	function warrior_edd_salesbooster_activation() {
			// wp_schedule_event( time(), $schedule, 'prefix_'.$schedule.'_event_hook' );
			warrior_create_salesbooster_edd();
			add_option( 'warrior_edd_enable_salesbooster', 'yes', '', 'yes' );
		} //close function

		add_filter( 'cron_schedules', 'warrior_edd_salesbooster_check_interval' );
		function warrior_edd_salesbooster_check_interval( $schedules ) {
			$schedules['warrior_3_hours'] = array(
					'interval'  => intval(3*60*60),
					'display'   => __( 'Every 3 Hours', 'warrior_sales_booster' )
			);
			$schedules['warrior_6_hours'] = array(
					'interval'  => intval(6*60*60),
					'display'   => __( 'Every 6 Hours', 'warrior_sales_booster' )
			);
			$schedules['warrior_weekly'] = array(
					'interval'  => intval(7*24*60*60),
					'display'   => __( 'Weekly', 'warrior_sales_booster' )
			);
			return $schedules;
		}

		if ( ! wp_next_scheduled( 'warrior_edd_salesbooster_cron' ) ) {
			$opt		= get_option('warrior_edd_salesbooster_setting');
			$interval	= 'daily';
			if( isset($opt['auto-update']) && !empty($opt['auto-update']) ){
				$interval = $opt['auto-update'];
			}
			// var_dump( $interval );
			wp_schedule_event( time(), $interval, 'warrior_edd_salesbooster_cron' );
		}
		else{
			// var_dump(time());
			// var_dump(wp_next_scheduled( 'warrior_edd_salesbooster_cron' ));
			// var_dump(wp_next_scheduled( 'warrior_edd_salesbooster_cron' ) - time());
		}

		add_action( 'warrior_edd_salesbooster_cron', 'warrior_edd_salesbooster_do_cron' );
		function warrior_edd_salesbooster_do_cron() {
			warrior_create_salesbooster_edd();
		}

	}
	else {
		function warrior_edd_salesbooster_admin_notice() {
	    ?>
	    <div class="error">
	        <p><?php esc_html_e( 'Themewarrior Sales Notification is an Extension to Easy Digital Downloads. Please activate Easy Digital Downloads first!', 'edd-sales-notification' ); ?></p>
	    </div>
	    <?php
	}
	add_action( 'admin_notices', 'warrior_edd_salesbooster_admin_notice' );
}
?>